/**
 *  \mainpage libpos API Reference
 *
 *  \section objects POS objects
 *
 */


#ifndef __LIBDEMO_L100_C___
#define __LIBDEMO_L100_C___

#include <stdlib.h>
#include <stdio.h>
#include <errno.h>
#include <string.h>
#include <memory.h>

#include "libDemo_L100.h"
#ifndef WIN32
# include <dlfcn.h>
#endif

// L100 process
extern void
_L100_process_function_list();
extern void
_L100_process_device();
extern void
_L100_process_config();
extern void
_L100_process_lcd();
extern void
_L100_process_pin();

extern void
_L100_display_device_menu();

extern void
_L100_display_config_menu();
extern void
_L100_display_lcd_menu();
extern void
_L100_display_pin_menu();

IDT_COMMON_PROCESS COMMON;
IDT_PROCESS idtech_process;
IDT_DEMO_LIB_DISPLAY_MENU idtech_display_menu_from_lib;

void
IDT_PROCESS_clean() {
    idtech_process.pProcess_function_list = NULL;
    idtech_process.pProcess_device        = NULL;
    idtech_process.pProcess_config        = NULL;
    idtech_process.pProcess_msr = NULL;
    idtech_process.pProcess_icc = NULL;
    idtech_process.pProcess_lcd = NULL;
    idtech_process.pProcess_emv = NULL;
    idtech_process.pProcess_pin = NULL;
}

void
libDemo_getMenuFn(IDT_DEMO_LIB_DISPLAY_MENU * _idtech_display_menu_from_lib) {
    *_idtech_display_menu_from_lib = idtech_display_menu_from_lib;
}

void
libDemo_init(IDT_COMMON_PROCESS _demo_Common_Process, IDT_DEMO_LIB_DISPLAY_MENU * _idtech_display_menu_from_lib) {
    COMMON = _demo_Common_Process;
    // intialize the process function
    IDT_PROCESS_clean();
    idtech_process.pProcess_function_list = _L100_process_function_list;
    idtech_process.pProcess_device        = _L100_process_device;
    idtech_process.pProcess_config        = _L100_process_config;
    idtech_process.pProcess_lcd = _L100_process_lcd;
    idtech_process.pProcess_pin = _L100_process_pin;

    // intialize the display menu callback
    idtech_display_menu_from_lib = *_idtech_display_menu_from_lib;
    idtech_display_menu_from_lib.pDisplay_Menu_device = _L100_display_device_menu;
    idtech_display_menu_from_lib.pDisplay_Menu_config = _L100_display_config_menu;
    idtech_display_menu_from_lib.pDisplay_Menu_lcd    = _L100_display_lcd_menu;
    idtech_display_menu_from_lib.pDisplay_Menu_pin    = _L100_display_pin_menu;
    *_idtech_display_menu_from_lib = idtech_display_menu_from_lib;
    // into the function menu selection
    idtech_process.pProcess_function_list();
}

#endif /* ifndef __LIBDEMO_L100_C___ */
