/**
 *  \mainpage libpos API Reference
 *
 *  \section objects POS objects
 *
 */


#ifndef __LIBDEMO_UniPayI_V_C___
#define __LIBDEMO_UniPayI_V_C___

#include <stdlib.h>
#include <stdio.h>
#include <errno.h>
#include <string.h>
#include <memory.h>
#include "libDemo_UniPayI_V.h"
// #include "demo_common.h"

#ifndef WIN32
# include <dlfcn.h>
#endif

// UniPayI_V process
extern void
_UniPayI_V_process_function_list();
extern void
_UniPayI_V_process_device();
// extern void _UniPayI_V_process_ctls();
extern void
_UniPayI_V_process_msr();
extern void
_UniPayI_V_process_icc();
extern void
_UniPayI_V_process_emv();

// extern void _UniPayI_V_display_ctls_menu();
extern void
_UniPayI_V_display_device_menu();
extern void
_UniPayI_V_display_msr_menu();
extern void
_UniPayI_V_display_icc_menu();
extern void
_UniPayI_V_display_emv_menu();


IDT_COMMON_PROCESS COMMON;
IDT_PROCESS idtech_process;
IDT_DEMO_LIB_DISPLAY_MENU idtech_display_menu_from_lib;


void
IDT_PROCESS_clean() {
    idtech_process.pProcess_function_list = NULL;
    idtech_process.pProcess_device        = NULL;
    idtech_process.pProcess_config        = NULL;
    idtech_process.pProcess_msr = NULL;
    idtech_process.pProcess_icc = NULL;
    idtech_process.pProcess_emv = NULL;
    idtech_process.pProcess_pin = NULL;
}

void
libDemo_getMenuFn(IDT_DEMO_LIB_DISPLAY_MENU * _idtech_display_menu_from_lib) {
    *_idtech_display_menu_from_lib = idtech_display_menu_from_lib;
}

void
libDemo_init(IDT_COMMON_PROCESS _demo_Common_Process, IDT_DEMO_LIB_DISPLAY_MENU * _idtech_display_menu_from_lib) {
    COMMON = _demo_Common_Process;
    // intialize the process function
    IDT_PROCESS_clean();
    idtech_process.pProcess_function_list = _UniPayI_V_process_function_list;
    idtech_process.pProcess_device        = _UniPayI_V_process_device;
    //	idtech_process.pProcess_ctls	= _UniPayI_V_process_ctls;
    idtech_process.pProcess_msr = _UniPayI_V_process_msr;
    idtech_process.pProcess_icc = _UniPayI_V_process_icc;
    idtech_process.pProcess_emv = _UniPayI_V_process_emv;


    // intialize the display menu callback
    //	idtech_display_menu_from_lib.pDisplay_Menu_ctls = _UniPayI_V_display_device_menu;//_UniPayI_V_display_ctls_menu;
    idtech_display_menu_from_lib = *_idtech_display_menu_from_lib;

    //	idtech_display_menu_from_lib.pDisplay_Menu_ctls = _UniPayII_V_display_ctls_menu;
    idtech_display_menu_from_lib.pDisplay_Menu_device = _UniPayI_V_display_device_menu;
    idtech_display_menu_from_lib.pDisplay_Menu_msr    = _UniPayI_V_display_msr_menu;
    idtech_display_menu_from_lib.pDisplay_Menu_icc    = _UniPayI_V_display_icc_menu;
    idtech_display_menu_from_lib.pDisplay_Menu_emv    = _UniPayI_V_display_emv_menu;
    *_idtech_display_menu_from_lib = idtech_display_menu_from_lib;
    // into the function menu selection
    idtech_process.pProcess_function_list();
}

#endif /* ifndef __LIBDEMO_UniPayI_V_C___ */
